# CreateCidr

## 1. API Description

This API (CreateCidr) is used to create a CIDR block.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name          | Required | Type                                                                                                     | Description                                                                                                                                                                                                                                                                                            |
| ----------------------- | -------- | -------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| regionId                | Yes      | String                                                                                                   | Region ID.                                                                                                                                                                                                                                                                                             |
| netmask                 | Yes      | [NetmaskInfo](https://docs.console.zenlayer.com/api-reference/compute/datastructure#netmaskinfo)         | CIDR block size and quantity.                                                                                                                                                                                                                                                                          |
| eipV4Type \[Deprecated] | No       | [EipNetworkType](https://docs.console.zenlayer.com/api-reference/compute/datastructure#eipnetworktype)   | <p>Network types of public IPv4.</p><p>Deprecated. Please use networkLineType instead.</p>                                                                                                                                                                                                             |
| networkLineType         | No       | [NetworkLineType](https://docs.console.zenlayer.com/api-reference/compute/datastructure#networklinetype) | Network types of public IPv4.                                                                                                                                                                                                                                                                          |
| name                    | No       | String                                                                                                   | <p>CIDR block name.</p><p>Length: 2–63 characters. Allowed characters: letters (A–Z, a–z), numbers (0–9), hyphen ( - ), slash ( / ), underscore ( \_ ), and period ( . ) Must start and end with a letter or number. If not specified, the assigned CIDR address will be used as the default name.</p> |
| resourceGroupId         | No       | String                                                                                                   | Resource group ID.                                                                                                                                                                                                                                                                                     |
| marketingOptions        | No       | [MarketingInfo](https://docs.console.zenlayer.com/api-reference/compute/datastructure#marketinginfo)     | Information on marketing campaigns.                                                                                                                                                                                                                                                                    |
| tags                    | No       | [TagAssociation](https://docs.console.zenlayer.com/api-reference/compute/datastructure#tagassociation)   | <p>Bound tags when creating the cidr block.</p><p>Tag keys must be unique.</p>                                                                                                                                                                                                                         |

## 3. Output Parameters

| Parameter Name | Type            | Description                                                                                                           |
| -------------- | --------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String          | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| cidrIds        | Array of String | ID list of created CIDR blocks.                                                                                       |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Create a CIDR block.**

<pre class="language-json"><code class="lang-json"><strong>POST /api/v2/zec HTTP/1.1
</strong>Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateCidr


Request:
{
  "regionId": "asia-east-1",
  "eipV4Type": "BGP_LINE",
  "netmask": {
    "netmask": 30,
    "amount": 1
  }
}

Response:
{
  "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
  "response": {
    "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F"
  }
}
</code></pre>

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code                                       | Description                                        |
| ---------------- | ------------------------------------------------ | -------------------------------------------------- |
| 400              | OPERATION\_DENIED\_EIP\_UNSUPPORT\_NETWORK\_TYPE | Elastic IP network billing model is not supported. |
| 400              | OPERATION\_DENIED\_CIDR\_INSUFFICIENT            | Insufficient CIDR blocks.                          |
| 400              | OPERATION\_DENIED\_CIDR\_IP\_COUNT\_REACH\_LIMIT | CIDR block quota limit exceeded.                   |
